var MAX_AGE_ONE_YEAR, NUM_USER_IMAGES, app, chat, express, gzip, newUserId, store;
NUM_USER_IMAGES = 10;
MAX_AGE_ONE_YEAR = {
  maxAge: 1000 * 60 * 60 * 24 * 365
};
gzip = require('connect-gzip');
express = require('express');
app = express.createServer().use(gzip.staticGzip(__dirname + '/public', MAX_AGE_ONE_YEAR)).use(express.favicon()).use(express.cookieParser()).use(express.session({
  secret: 'dont_tell'
})).use(gzip.gzip());
chat = require('./chat.server');
store = chat.createStore({
  redis: {
    db: 3
  },
  listen: app
});
store.flush();
newUserId = 0;
app.get('/:room?', function(req, res) {
  var room, session, userId, _room;
  room = req.params.room;
  if (!(room && /^[-\w ]+$/.test(room))) {
    return res.redirect('/lobby');
  }
  _room = room.toLowerCase().replace(/[_ ]/g, '-');
  if (_room !== room) {
    return res.redirect("/" + _room);
  }
  session = req.session;
  userId = typeof session.userId === 'number' ? session.userId : session.userId = newUserId++;
  room = req.params.room;
  return store.subscribe({
    _room: "rooms." + room + ".**"
  }, "users.**", function(err, model) {
    model.setNull('_room.messages', []);
    model.setNull("users." + userId, {
      name: 'User ' + (userId + 1),
      picClass: 'pic' + (userId % NUM_USER_IMAGES)
    });
    model.set('_session', {
      userId: userId,
      user: model.ref('users', '_session.userId'),
      newComment: '',
      numMessages: model.get('_room.messages').length
    });
    return chat.view.sendHtml(res, model);
  });
});
app.listen(3003);
console.log("Go to: http://localhost:3003/lobby");