var Dom, View, cache, minify, modelHelper, uglify;
uglify = require('uglify-js');
module.exports = View = require('./View');
Dom = require('./Dom');
modelHelper = require('./modelHelper');
View.prototype._register = function(name, fn) {
  return this._views[name] = fn;
};
View.prototype._init = function(model) {
  this.dom = new Dom(this.model = modelHelper.init(model));
  return this._idCount = 0;
};
View.prototype.sendHtml = function(res, model, ctx) {
  var clientName, doctype, dom, head, initEnd, initStart, tail, title;
  this._init(model);
  dom = this.dom;
  if (!res.getHeader('content-type')) {
    res.setHeader('Content-Type', 'text/html; charset=utf-8');
  }
  doctype = this.get('Doctype', ctx) || '<!DOCTYPE html><meta charset=utf-8>';
  title = View.htmlEscape(this.get('Title', ctx)) || 'Derby app';
  head = this.get('Head', ctx);
  res.write("" + doctype + "<title>" + title + "</title>" + head);
  res.write(this.get('Body', ctx));
  clientName = this._clientName;
  res.write("<script>function $(i){return document.getElementById(i)}" + ("function " + clientName + "(){" + clientName + "=1}") + ("" + (minify(this._loadFuncs)) + "</script>") + this.get('Script', ctx) + ("<script defer async onload=" + clientName + "() src=" + this._jsFile + "></script>"));
  tail = this.get('Tail', ctx);
  initStart = "<script>(function(){function f(){setTimeout(function(){" + ("" + clientName + "=require('./" + clientName + "')(" + this._idCount + ",") + JSON.stringify(this._paths) + ',';
  initEnd = ',' + JSON.stringify(model.__events.get()) + ',' + JSON.stringify(dom.events.get()) + (")},0)}" + clientName + "===1?f():" + clientName + "=f})()</script>" + tail);
  return model.bundle(function(bundle) {
    return res.end(initStart + bundle.replace(/<\//g, '<\\/') + initEnd);
  });
};
cache = {};
minify = function(js) {
  if (cache[js]) {
    return cache[js];
  }
  return cache[js] = uglify(js);
};