var View, crypto, fs, path, racer;
racer = require('racer');
View = require('./View.server');
path = require('path');
fs = require('fs');
crypto = require('crypto');
module.exports = {
  options: {},
  configure: function(options) {
    this.options = options;
  },
  createApp: function(appModule, appExports) {
    var bundle, minify, staticDir, staticPath, staticRoot, view;
    racer.util.merge(appExports, racer);
    appExports.view = view = new View;
    appExports.ready = function() {};
    view._clientName = this.options.name || path.basename(appModule.filename, '.js');
    staticRoot = this.options.root || path.dirname(appModule.filename) + '/public';
    staticDir = this.options.dir || 'gen';
    staticPath = path.join(staticRoot, staticDir);
    minify = process.env.NODE_ENV === 'production';
    bundle = function() {
      return racer.js({
        minify: minify,
        require: appModule.filename
      }, function(js) {
        var filePath, filename;
        filename = crypto.createHash('md5').update(js).digest('base64') + '.js';
        filename = filename.replace(/[\/\+=]/g, function(match) {
          switch (match) {
            case '/':
              return '-';
            case '+':
              return '_';
            case '=':
              return '';
          }
        });
        view._jsFile = "/" + staticDir + "/" + filename;
        filePath = path.join(staticPath, filename);
        return fs.writeFile(filePath, js);
      });
    };
    path.exists(staticPath, function(exists) {
      if (exists) {
        return bundle();
      }
      return path.exists(staticRoot, function(exists) {
        if (exists) {
          return fs.mkdir(staticPath, 0777, function(err) {
            return bundle();
          });
        }
        return fs.mkdir(staticRoot, 0777, function(err) {
          return fs.mkdir(staticPath, 0777, function(err) {
            return bundle();
          });
        });
      });
    });
    return appExports;
  }
};