var addDomEvent, distribute, modelPath, replaceIndex;
replaceIndex = function(data, path, noReplace) {
  var i, indicies;
  if (noReplace || !(indicies = data.$i) || !path) {
    return path;
  }
  i = 0;
  return path.replace(/\$#/g, function() {
    return indicies[i++];
  });
};
module.exports = {
  modelPath: modelPath = function(data, name, noReplace) {
    var datum, i, path, paths;
    if ((paths = data.$paths) && name.charAt(0) === '.') {
      if (name === '.') {
        return replaceIndex(data, paths[0], noReplace);
      }
      i = /^\.+/.exec(name)[0].length - 1;
      return replaceIndex(data, paths[i], noReplace) + name.substr(i);
    }
    if (!((datum = data[name]) && (path = datum.model))) {
      return null;
    }
    return path.replace(/\(([^)]+)\)/g, function(match, name) {
      return data[name];
    });
  },
  addDomEvent: addDomEvent = function(events, attrs, name, eventNames, getMethod, property, invert) {
    var args, delay, eventName, i, isArray, prefix, _len, _ref;
    args = [null, null, getMethod, property];
    if (isArray = Array.isArray(eventNames)) {
      for (i = 0, _len = eventNames.length; i < _len; i++) {
        eventName = eventNames[i];
        eventNames[i] = eventName.split(',');
      }
    } else {
      _ref = eventNames.split(','), eventName = _ref[0], delay = _ref[1];
      if (delay != null) {
        args.push(delay);
      }
    }
    prefix = invert ? '!' : '';
    return events.push(function(data, modelEvents, domEvents) {
      var _i, _len2, _ref2, _results;
      args[0] = prefix + modelPath(data, name);
      args[1] = attrs._id || attrs.id;
      if (!isArray) {
        return domEvents.bind(eventName, args);
      }
      _results = [];
      for (_i = 0, _len2 = eventNames.length; _i < _len2; _i++) {
        _ref2 = eventNames[_i], eventName = _ref2[0], delay = _ref2[1];
        _results.push(domEvents.bind(eventName, delay != null ? args.concat(delay) : args));
      }
      return _results;
    });
  },
  distribute: distribute = function(events, attrs, eventName) {
    var args;
    args = ['$dist', null];
    return events.push(function(data, modelEvents, domEvents) {
      args[1] = attrs._id || attrs.id;
      return domEvents.bind(eventName, args);
    });
  },
  parsePlaceholder: {
    'value': {
      input: function(events, attrs, name) {
        var eventNames;
        if ('x-blur' in attrs) {
          delete attrs['x-blur'];
          eventNames = 'change';
        } else {
          eventNames = ['keyup', 'keydown', 'paste,0', 'dragover,0'];
        }
        addDomEvent(events, attrs, name, eventNames, 'prop', 'value');
        return {
          method: 'propPolite'
        };
      }
    },
    'checked': {
      '*': function(events,  attrs, name, invert) {
        addDomEvent(events, attrs, name, 'change', 'prop', 'checked', invert);
        return {
          method: 'prop',
          bool: true
        };
      }
    },
    'selected': {
      '*': function(events, attrs, name, invert) {
        addDomEvent(events, attrs, name, 'change', 'prop', 'selected', invert);
        return {
          method: 'prop',
          bool: true
        };
      }
    },
    'disabled': {
      '*': function() {
        return {
          method: 'prop',
          bool: true
        };
      }
    }
  },
  parseElement: {
    'select': function(events, attrs) {
      distribute(events, attrs, 'change');
      return {
        addId: true
      };
    }
  },
  parseAttr: {
    'x-bind': {
      '*': function(events, attrs, name, fn) {
        var args, delay, _ref;
        delete attrs['x-bind'];
        _ref = name.split(','), name = _ref[0], delay = _ref[1];
        args = [fn, null];
        if (delay != null) {
          args.push(delay);
        }
        events.push(function(data, modelEvents, domEvents) {
          args[1] = attrs._id || attrs.id;
          return domEvents.bind(name, args);
        });
        return {
          addId: true
        };
      },
      a: function(events, attrs, name) {
        if (name === 'click' && !('href' in attrs)) {
          attrs.href = '#';
          if (!('onclick' in attrs)) {
            return attrs.onclick = 'return false';
          }
        }
      },
      form: function(events, attrs, name) {
        if (name === 'submit') {
          if (!('onsubmit' in attrs)) {
            return attrs.onsubmit = 'return false';
          }
        }
      }
    }
  }
};